;Copyright 2015 Daniel Green, v2.00.0b modified 03/24/15 8:43am

;Lock State is free for both business and personal use. It can be freely modified and redistributed providing that:
;1. all notices remain intact.
;2. you acknowledge where it originally came from.
;3. it is only used for legal and ethical purposes.
;4. no profit is derived from its distribution.

#noenv
#singleinstance, ignore
setbatchlines, -1
setworkingdir, %a_scriptdir%

onmessage(0x11, "_on_shutdown")

menu, tray, nostandard
menu, tray, click, 1
menu, tray, tip, Lock State
menu, tray, add, States, states
menu, tray, add, Settings, settings_show
menu, tray, add, About, about
menu, tray, add
menu, tray, add, Exit, exit
menu, tray, default, states

gosub, get_settings
gosub, osd_create
gosub, settings_gui_create

global locked_numlock := 0, locked_capslock := 0, locked_scrolllock := 0, save_states
gosub, % save_states ? "get_saved_states" : "load_colors"
return

numlock::
capslock::
scrolllock::
 {
   if (!locked_%a_thishotkey%)
    {
      _toggle_key(a_thishotkey)
      if (sounds)
       {
         soundplay, sounds\beep.wav
       }
      color := getkeystate(a_thishotkey, "t") ? on_color : off_color
      guicontrol, 1:+background%color%, _%a_thishotkey%
      guicontrol, 1:hide, txt_%a_thishotkey%
      guicontrol, 1:show, txt_%a_thishotkey%
    }
   gosub, osd_show
   keywait, % a_thishotkey
 }
return

!numlock::
!capslock::
!scrolllock::
 {
   _toggle_lock(ltrim(a_thishotkey, "!"))
   if (sounds)
    {
      soundplay, sounds\click.wav
    }
   gosub, osd_show
   keywait, % ltrim(a_thishotkey, "!")
 }
return

osd_show:
 {
   v_offset := _percent(_percent(a_screendpi, 96, 1), 186, 0)
   h_offset := _percent(_percent(a_screendpi, 96, 1), 16, 0)

   sysget, var_, monitorworkarea
   x := var_right - (v_offset + 10)
   y := var_bottom - (h_offset + 10)

   gui, 1:show, x%x% y%y% na, OSD
   settimer, osd_cancel, -%time%
 }
return

_percent(input, base, mode)
 {
   return floor(mode ? (input / base) * 100 : base * (input / 100))
 }

osd_create:
 {
   gui, 1:-caption +toolwindow +alwaysontop +lastfound
   gui, 1:color, 8b0fc6
   gui, 1:font, s10 w600, Arial Bold
   gui, 1:margin, 0, 0
   winset, transcolor, 8b0fc6

   gui, 1:add, listview, x0 y0 w60 h16 -hdr -e0x200 -multi v_numlock glv altsubmit
   gui, 1:add, text, x0 y0 w60 h16 0x201 backgroundtrans vtxt_numlock, N

   gui, 1:add, listview, x63 y0 w60 h16 -hdr -e0x200 -multi v_capslock glv altsubmit
   gui, 1:add, text, x63 y0 w60 h16 0x201 backgroundtrans vtxt_capslock, C

   gui, 1:add, listview, x126 y0 w60 h16 -hdr -e0x200 -multi v_scrolllock glv altsubmit
   gui, 1:add, text, x126 y0 w60 h16 0x201 backgroundtrans vtxt_scrolllock, S
 }
return

settings_gui_create:
 {
   gui, 2:font, s8
   
   gui, 2:add, button, x210 y130 w60 h20 g2guiclose, Cancel
   gui, 2:add, button, default x270 y130 w60 h20 gsave, Save
   
   gui, 2:add, groupbox, x10 y10 w100 h50, On color:
   gui, 2:add, edit, limit6 x20 y30 w50 h20 von_color gshow_color
   gui, 2:add, progress, x80 y30 w20 h20 disabled von_color_box

   gui, 2:add, groupbox, x120 y10 w100 h50 , Off color:
   gui, 2:add, edit, limit6 x130 y30 w50 h20 voff_color gshow_color
   gui, 2:add, progress, x190 y30 w20 h20 disabled voff_color_box

   gui, 2:add, groupbox, x230 y10 w100 h50, Text color:
   gui, 2:add, edit, limit6 x240 y30 w50 h20 vtext_color gshow_color
   gui, 2:add, progress, x300 y30 w20 h20 disabled vtext_color_box

   gui, 2:add, groupbox, x10 y70 w320 h50, Misc:
   gui, 2:add, checkbox, x20 y90 w60 h20 vsounds, Sounds
   gui, 2:add, checkbox, x95 y90 w110 h20 vsave_states, Remember states
   gui, 2:add, text, x213 y93 w65 h20, Display time:
   gui, 2:add, edit, number limit5 x280 y90 w40 h20 vtime
 }
return

states:
 {
   count++
   settimer, actions, 180
 }
return

actions:
 {
   if (count = 1)
    {
      gosub, osd_show
    }
   else if (count > 1)
    {
      gosub, settings_show
    }
   count := 0
 }
return

show_color:
 {
   guicontrolget, gui_color, , %a_guicontrol%
   guicontrol, 2:+background%gui_color%, %a_guicontrol%_box
 }
return

lv:
{
   if (a_guievent = "normal") or (a_guievent = "doubleclick")
    {
      control := ltrim(a_guicontrol, "_")
      if (!locked_%control%)
       {
         _toggle_key(control)
         if (sounds)
          {
            soundplay, sounds\beep.wav
          }
         color := getkeystate(control, "t") ? on_color : off_color
         guicontrol, 1:+background%color%, %a_guicontrol%
         guicontrol, 1:hide, txt%a_guicontrol%
         guicontrol, 1:show, txt%a_guicontrol%
       }
      settimer, osd_cancel, -%time%
    }
   else if (a_guievent = "rightclick")
    {
      _toggle_lock(ltrim(a_guicontrol, "_"))
      if (sounds)
       {
         soundplay, sounds\click.wav
       }
      settimer, osd_cancel, -%time%
    }
 }
return

get_settings:
 {
   iniread, on_color, settings.ini, settings, on, 83BEB0
   iniread, off_color, settings.ini, settings, off, 553D73
   iniread, text_color, settings.ini, settings, text, FFFFFF
   iniread, sounds, settings.ini, settings, sounds, 1
   iniread, save_states, settings.ini, settings, states, 0
   iniread, time, settings.ini, settings, time, 3000
   on_color := on_color = "" ? "83BEB0" : substr(on_color, 1, 6)
   on_color := on_color = "8B0FC6" ? "8B0FC7" : on_color
   off_color := off_color = "" ? "553D73" : substr(off_color, 1, 6)
   off_color := off_color = "8B0FC6" ? "8B0FC7" : off_color
   text_color := text_color = "" ? "FFFFFF" : substr(text_color, 1, 6)
   text_color := text_color = "8B0FC6" ? "8B0FC7" : text_color
   sounds := sounds != 1 ? sounds != 0 ? 1 : sounds : sounds
   save_states := save_states != 1 ? save_states != 0 ? 1 : save_states : save_states
   time := time = "" ? 3000 : time
 }
return

get_saved_states:
 {
   iniread, numlock, settings.ini, states, numlock, % getkeystate("numlock", "t") . "0|"
   iniread, capslock, settings.ini, states, capslock, % getkeystate("capslock", "t") . "0|"
   iniread, scrolllock, settings.ini, states, scrolllock, % getkeystate("scrolllock", "t") . "0|"

   stringsplit, numlock, numlock, |
   stringsplit, capslock, capslock, |
   stringsplit, scrolllock, scrolllock, |

   setnumlockstate, % numlock1 ? "on" : "off"
   setcapslockstate, % capslock1 ? "on" : "off"
   setscrolllockstate, % scrolllock1 ? "on" : "off"

   gosub, load_colors

   numlock2 ? _toggle_lock("numlock") : ""
   capslock2 ? _toggle_lock("capslock") : ""
   scrolllock2 ? _toggle_lock("scrolllock") : ""
 }
return

load_settings:
 {
   guicontrol, 2:, on_color, %on_color%
   guicontrol, 2:, off_color, %off_color%
   guicontrol, 2:, text_color, %text_color%
   guicontrol, 2:, sounds, %sounds%
   guicontrol, 2:, save_states, %save_states%
   guicontrol, 2:, time, %time%
 }
return

load_colors:
 {
   n_color := getkeystate("numlock", "t") ? on_color : off_color
   c_color := getkeystate("capslock", "t") ? on_color : off_color
   s_color := getkeystate("scrolllock", "t") ? on_color : off_color

   guicontrol, 1:+background%n_color%, _numlock
   guicontrol, 1:+background%c_color%, _capslock
   guicontrol, 1:+background%s_color%, _scrolllock
   
   gui, 1:font, c%text_color%
   
   guicontrol, 1:font, txt_numlock
   guicontrol, 1:font, txt_capslock
   guicontrol, 1:font, txt_scrolllock
   
   n_color := c_color := s_color := ""
 }
return

save:
 {
   gui, 2:submit
   
   stringupper, on_color, on_color
   stringupper, off_color, off_color
   stringupper, text_color, text_color
   
   if regexmatch(on_color . off_color . text_color, "[^0-9A-F]")
    {
      msgbox, 48, Error..., One or more of the color fields contains unsupported characters.`nHex colors may only consist of 0-9 a-f A-F., 10
      return
    }
   else if strlen(on_color . off_color . text_color) != 18
    {
      msgbox, 48, Error..., One or more of the color fields are incomplete.`nHex colors must consist of 6 characters., 10
      return
    }

   on_color := on_color = "8B0FC6" ? "8B0FC7" : on_color
   off_color := off_color = "8B0FC6" ? "8B0FC7" : off_color
   text_color := text_color = "8B0FC6" ? "8B0FC7" : text_color
   
   gosub, load_colors

   iniwrite, %on_color%, settings.ini, settings, on
   iniwrite, %off_color%, settings.ini, settings, off
   iniwrite, %text_color%, settings.ini, settings, text
   iniwrite, %sounds%, settings.ini, settings, sounds
   iniwrite, %save_states%, settings.ini, settings, states
   iniwrite, %time%, settings.ini, settings, time
 }
return

_toggle_key(key)
 {
   if (key = "capslock")
    {
      setcapslockstate, % getkeystate(key, "t") ? "off" : "on"
    }
   else if (key = "scrolllock")
    {
      setscrolllockstate, % getkeystate(key, "t") ? "off" : "on"
    }
   else if (key = "numlock")
    {
      setnumlockstate, % getkeystate(key, "t") ? "off" : "on"
    }
   return
 }

_toggle_lock(key)
 {
   if (key = "numlock")
    {
      if (locked_numlock)
       {
         setnumlockstate
         guicontrol, 1:, txt_numlock, N
         locked_numlock := 0
       }
      else
       {
         setnumlockstate, % getkeystate(key, "t") ? "alwayson" : "alwaysoff"
         guicontrol, 1:, txt_numlock, LOCKED
         locked_numlock := 1
       }
    }
   else if (key = "capslock")
    {
      if (locked_capslock)
       {
         setcapslockstate
         guicontrol, 1:, txt_capslock, C
         locked_capslock := 0
       }
      else
       {
         setcapslockstate, % getkeystate(key, "t") ? "alwayson" : "alwaysoff"
         guicontrol, 1:, txt_capslock, LOCKED
         locked_capslock := 1
       }
    }
   else if (key = "scrolllock")
    {
      if (locked_scrolllock)
       {
         setscrolllockstate
         guicontrol, 1:, txt_scrolllock, S
         locked_scrolllock := 0
       }
      else
       {
         setscrolllockstate, % getkeystate(key, "t") ? "alwayson" : "alwaysoff"
         guicontrol, 1:, txt_scrolllock, LOCKED
         locked_scrolllock := 1
       }
    }
   return
 }

about:
 {
   if (about_gui != 1)
    {
      gosub, get_about
      gui, 3:font, s8
      gui, 3:add, button, x340 y275 w60 h20 ghome_site, Home
      gui, 3:add, button, default x400 y275 w60 h20 g3guiclose, OK
      gui, 3:add, edit, +readonly vscroll x10 y10 w450 h260, %about%
      gui, 3:show, center w470 h300, About Lock State
      about_gui := 1
    }
   else
    {
      gui, 3:destroy
      about_gui := 0
    }
 }
return

get_about:
 {
about := 
(
"Lock State v2.00.0b

Copyright 2015 Daniel Green

Lock State provides an on screen display to indicate the states of the NumLock, CapsLock and ScrollLock keys.

Lock State is free for both business and personal use. It can be freely modified and redistributed providing that:
   1. All notices remain intact.
   2. You acknowledge where it originally came from.
   3. It is only used for legal and ethical purposes.
   4. No profit is derived from its distribution.

Features:
   Shows key states via a display in the lower right corner.
   Has optional indicator sound, so you will know if a state changes accidentally.
   Can lock the current state of each key.
   States can be saved on exit, and restored the next time Lock State is launched.
   Color scheme and behavior can be broadly customized.
   Portable, can run from removable media and makes no changes to the host system.
   Open source, written in AutoHotkey (http://www.ahkscript.org).

Instructions:
   The on screen display will appear when one of the lock keys is pressed, or when the tray icon is single clicked.
   Individual states can be changed, or locked/unlocked, by left/right clicking the on screen display.
   States can also be locked/unlocked via ALt- hotkey, i.e. Alt-CapsLock.
   Settings are accessible from the tray menu or by double clicking the tray icon.
   To restore default settings delete settings.ini and restart the application.

Requirements:
   Windows XP +

History:
   v2.00.0b
      Complete rewrite and redesign.
   v1.00.1b
      Bug fix.
   v1.00.0b
      Initial beta release.

beep.wav:
   Robot Blip 2
   Downloaded from http://soundbible.com
   Recorded by Marianne Gagnon
   Released under a Attribution 3.0 license
click.wav:
   Click2
   Downloaded from http://soundbible.com
   Recorded by Sebastian
   Released under a Attribution 3.0 license

Note:
   Sound files have been modified from those available on soundbible.com. This was done to both change how they sound, and to reduce file sizes.

Thanks to:
   Several members of the autohotkey.com and ahkscript.org communities for their help and advice in creating Lock State. In particular, Masonjar13 for his patient and repeated bug testing."
)
 }
return

home_site:
 {
   run, http://crzyinc.weebly.com/.html
 }
return

settings_show:
 {
   gosub, get_settings
   gosub, load_settings
   gui, 2:show, w340 h160, Settings
 }
return

osd_cancel:
 {
   gui, 1:cancel
 }
return

2guiclose:
 {
   gui, 2:cancel
   gosub, load_colors
 }
return

3guiclose:
 {
   gui, 3:destroy
   about_gui := 0
 }
return

_on_shutdown()
 {
   if (save_states)
    {
      numlock := getkeystate("numlock", "t") . "|" . locked_numlock
      capslock := getkeystate("capslock", "t") . "|" . locked_capslock
      scrolllock := getkeystate("scrolllock", "t") . "|" . locked_scrolllock

      iniwrite, %numlock%, settings.ini, states, numlock
      iniwrite, %capslock%, settings.ini, states, capslock
      iniwrite, %scrolllock%, settings.ini, states, scrolllock
    }
   exitapp
 }

exit:
 {
   _on_shutdown()
 }
return